import { PrimaryKeyProp, defineEntity, p } from '@mikro-orm/core';

export class IcrHomeworkextracurricular {
  [PrimaryKeyProp]?: 'Id';
  Id!: bigint;
  Name?: string;
  Content?: string;
  StartTime!: Date;
  EndTime!: Date;
  StudentTemplateId!: bigint;
  Status!: number;
  Revision!: number;
  CreatedBy?: bigint;
  CreatedTime!: Date;
  UpdatedBy?: bigint;
  UpdatedTime?: Date;
  IsDeleted!: unknown;
  ReviewIds?: string;
}

export const IcrHomeworkextracurricularSchema = defineEntity({
  class: IcrHomeworkextracurricular,
  comment: '课外作业',
  properties: {
    Id: p.bigint().primary().name('Id').unsigned(false).autoincrement(false).comment('主键Id'),
    Name: p.string().name('Name').nullable().comment('活动名称'),
    Content: p.string().name('Content').nullable().comment('活动内容'),
    StartTime: p.datetime().name('StartTime').length(3).comment('发布时间'),
    EndTime: p.datetime().name('EndTime').length(3).comment('结束时间'),
    StudentTemplateId: p.bigint().name('StudentTemplateId').comment('引用学生模板Id'),
    Status: p.integer().name('Status').comment('状态'),
    Revision: p.integer().name('Revision').comment('乐观锁'),
    CreatedBy: p.bigint().name('CreatedBy').nullable().comment('创建者用户Id'),
    CreatedTime: p.datetime().name('CreatedTime').length(3).comment('创建时间'),
    UpdatedBy: p.bigint().name('UpdatedBy').nullable().comment('修改者用户Id'),
    UpdatedTime: p.datetime().name('UpdatedTime').length(3).nullable().comment('修改时间'),
    IsDeleted: p.array().name('IsDeleted').comment('是否删除'),
    ReviewIds: p.string().name('ReviewIds').length(5000).nullable().comment('批阅人ids'),
  },
});
